<id>
Advanced Profile Lock (Dutch)
</id>

<version>
1.0
</version>

<mod info>
This SP1.1 mod adds the following features to your board:

- Mandatory Age and Gender for any user filling out his/her profile
- Gender auto lock after given number of changes
- Birthdate auto lock after given number of changes

All options are controlled in de admin center (on/off) and max number of changes allowed
Locks can be reset by the admin in the user's profile page.

Version History:

V1.0
Initial release
Bug fix in birth date checking of SP1.1 (yes it still had a bug in it)

Mod Description:

If Profile Lock is activated the user will see the number of changes done and left in his/her profile and also if the Auto lock function is activated or not.
The admin can lock birthdate and gender for each user independantly in the users profile by setting the change value equal or higher then the max allowed changes value.
If a user reaches the max allowed changes he cannot change gender or birthdate and sees LOCKED ! below either item in the profile.
This mod generated one new file per user in /Members called <username>.prolock
If you delete this file any locks will also be released and the file will be generated again after a profile update.

How To Install :

As usual using boardmod 2.5
Install the mod and upload the modified files being:
Profile.pl
AdminEdit.pl
dutch.lng

Enjoy,

webmaster spikecity.net
</mod info>

<author>
Ron A.J. Hartendorp
</author>

<homepage>
http://www.spikecity.net
</homepage>

<edit file>
dutch.lng
</edit file>

<search for>
$yycopyright = qq~  $mbname<BR>\n  <HR size="1" width="250" color="$color{'windowbg3'}" class="windowbg3">\n<a href="http://yabb.xnull.com">YaBB 1 Gold - SP 1.1</a><BR>\n  Copyright  2001-2002, <a href="http://www.xnull.com">X-Null</a>. Alle rechten voorbehouden.~;
</search for>

<add before>

########### Profile Lock Mod ##########
	$prolocktxt{'1'} = "Je dient een correcte geboortedatum in te vullen";
	$prolocktxt{'2'} = "Je dient een geslacht te kiezen";
	$prolocktxt{'3'} = "Aktiveer Profiel Blokkering";
	$prolocktxt{'4'} = "Aktiveer Verplichte leeftijd en geslacht in profiel ?";
	$prolocktxt{'5'} = "Aantal geboortedatum wijzigingen";
	$prolocktxt{'6'} = "Aantal geslachtsinstelling wijzigingen";
	$prolocktxt{'7'} = "Automatisch Blokkeren van Leeftijd en geslacht na profiel update ?";
	$prolocktxt{'8'} = "GEBLOKKEERD!";
	$prolocktxt{'9'} = "Aantal toegestane veranderingen voordat auto blokkering activeert";
	$prolocktxt{'10'} = "van";
	$prolocktxt{'11'} = "Wijziging";
	$prolocktxt{'12'} = "Auto Blokkering Actief";
	$prolocktxt{'13'} = "Auto Blokkering Uitgeschakeld";
########### Profile Lock Mod ##########

</add before>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
	if( $member{'bday1'} ne "" || $member{'bday1'} ne "" || $member{'bday1'} ne "" ) {
		&fatal_error("$txt{'567'}") if( $member{'bday1'} !~ /^[0-9]+$/ || $member{'bday2'} !~ /^[0-9]+$/ || $member{'bday3'} !~ /^[0-9]+$/ || length($member{'bday3'}) < 4 );
		&fatal_error("$txt{'567'}") if( $member{'bday1'} < 1 || $member{'bday1'} > 12 || $member{'bday2'} < 1 || $member{'bday2'} > 31 || $member{'bday3'} < 1901 || $member{'bday3'} > $year-5 );
	}
</search for>

<replace>
	if( $member{'bday1'} ne "" || $member{'bday2'} ne "" || $member{'bday3'} ne "" ) {
		&fatal_error("$txt{'567'}") if( $member{'bday1'} !~ /^[0-9]+$/ || $member{'bday2'} !~ /^[0-9]+$/ || $member{'bday3'} !~ /^[0-9]+$/ || length($member{'bday3'}) < 4 );
		&fatal_error("$txt{'567'}") if( $member{'bday1'} < 1 || $member{'bday1'} > 12 || $member{'bday2'} < 1 || $member{'bday2'} > 31 || $member{'bday3'} < 1901 || $member{'bday3'} > $year-5 );
	}
</replace>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
	if ($showgenderimage) { $sgichecked = "checked" }
</search for>

<add after>

###### Profile Lock Mod ######	
	if ($enable_prolock) { $prolockon = "checked" }
	if ($enable_prolock_mandatory) { $prolockmandatory = "checked" }
	if ($enable_prolock_auto) { $prolockauto = "checked" }
###### Profile Lock Mod ######	

</add after>

<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'386'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showgenderimage" $sgichecked></td>
  </tr><tr>
</search for>

<add after>

<!--- ###### Profile Lock Mod ###### --->
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$prolocktxt{'3'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_prolock" $prolockon></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$prolocktxt{'4'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_prolock_mandatory" $prolockmandatory></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$prolocktxt{'7'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_prolock_auto" $prolockauto></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$prolocktxt{'9'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="prolock_max_allowed" size="3" value="$prolock_max_allowed"></td>
  </tr><tr>
<!--- ###### Profile Lock Mod ###### --->

</add after>

<search for>
	# If empty fields are submitted, set them to default-values to save yabb from crashing
</search for>

<add before>

###### Profile Lock Mod ######	
	$prolockon = $FORM{'enable_prolock'} ? 1 : 0;
	$prolockmandatory = $FORM{'enable_prolock_mandatory'} ? 1 : 0;
	$prolockauto = $FORM{'enable_prolock_auto'} ? 1 : 0;
	$prolock_max_allowed = $FORM{'prolock_max_allowed'} || 5;
###### Profile Lock Mod ######	

</add before>

<search for>
########## File Locking ##########
</search for>

<add before>

###### Profile Lock Mod ######	
\$enable_prolock = $prolockon;				# Enables the Profile Lock Option
\$enable_prolock_mandatory = $prolockmandatory;		# Enables mandatory age and gender in the Profile Lock Option
\$enable_prolock_auto = $prolockauto;			# Enables Auto Lock of the Profile after completion.
\$prolock_max_allowed = $prolock_max_allowed;		# Number of profile changes allowed befor auto locking
###### Profile Lock Mod ######	


</add before>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
	$memsettings[9] =~ tr/+/ /;
	$memsettings[10] =~ tr/+/ /;
</search for>

<add after>

###### Profile Lock Mod ######
if ($enable_prolock == 1) {
	$prolockgender_count = 0;
	$prolockage_count = 0;
	$prolockgender_old = $memsettings[11];
	$prolockbirthdate_old = $memsettings[16];
	fopen(FILE, "$memberdir/$INFO{'username'}.prolock");
	@prolocksettings=<FILE>;
	fclose(FILE);
	foreach (@prolocksettings) { $_ =~ s~[\n\r]~~g; }
	$prolockgender_count = $prolocksettings[1];
	$prolockage_count = $prolocksettings[0];
	if($prolockgender_count==""){$prolockgender_count = 0;}
	if($prolockage_count==""){$prolockage_count = 0;}
}
	$hidedayormonth = qq~<input type="hidden" name="bday1" value="$umonth"><input type="hidden" name="bday2" value="$uday"><input type="hidden" name="bday3" value="$uyear">~;
###### Profile Lock Mod ######

</add after>

<search for>
	<td width="320"><font size=2><b>$txt{'231'}: </b></font></td>
	<td>
	<select name="gender" size="1">
	 <option value=""></option>
	 <option value="Male"$GenderMale>$txt{'238'}</option>
	 <option value="Female"$GenderFemale>$txt{'239'}</option>
	</select>
	</td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'563'}:</b></font></td>
	<td><font size="1">$dayormonth$txt{'566'}<input type="text" name="bday3" size="4" maxlength="4" value="$uyear"></font></td>
      </tr><tr>
</search for>

<replace>
<!--- ###### Profile Lock Mod ###### --->
	<td width="320"><font size=2><b>$txt{'231'}: <input type="hidden" name="plg_old" value="$prolockgender_old"></b></font></td>
	<td>
	<select name="gender" size="1">
 ~;
if ($enable_prolock == 1) {
	if($enable_prolock_auto ==1){$prolock_txt = $prolocktxt{'12'};} else {$prolock_txt = $prolocktxt{'13'};}
	if($prolockgender_count < $prolock_max_allowed) {
	$yymain .= qq~
	 <option value=""></option>
	 <option value="Male"$GenderMale>$txt{'238'}</option>
	 <option value="Female"$GenderFemale>$txt{'239'}</option>
	</select><BR><I> $prolocktxt{'11'} $prolockgender_count $prolocktxt{'10'} $prolock_max_allowed. ($prolock_txt)</I>
	~;
	}
	if($prolockgender_count >= $prolock_max_allowed && $memsettings[11] eq 'Male') {
	$yymain .= qq~
	 <option value="Male"$GenderMale>$txt{'238'}</option>
	</select><BR><B> $prolocktxt{'8'} ($prolock_txt)</B>
	~;
	}
	if($prolockgender_count >= $prolock_max_allowed && $memsettings[11] eq 'Female') {
	$yymain .= qq~	
	 <option value="Female"$GenderFemale>$txt{'239'}</option>
	</select><BR><B> $prolocktxt{'8'} ($prolock_txt)</B>
	~;
	}
} else {
	$yymain .= qq~
	 <option value=""></option>
	 <option value="Male"$GenderMale>$txt{'238'}</option>
	 <option value="Female"$GenderFemale>$txt{'239'}</option>
	</select>
	~;
}
	$yymain .= qq~
	</td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'563'}: <input type="hidden" name="pla_old" value="$prolockbirthdate_old"></b></font></td>
	~;
if ($enable_prolock == 1) {
	if($prolockage_count < $prolock_max_allowed) {
	$yymain .= qq~
	<td><font size="1">$dayormonth$txt{'566'}<input type="text" name="bday3" size="4" maxlength="4" value="$uyear"></font><BR><I> $prolocktxt{'11'} $prolockage_count $prolocktxt{'10'} $prolock_max_allowed. ($prolock_txt)</I></td></tr>
	~;
	}
	if($prolockage_count >= $prolock_max_allowed) {
	$yymain .= qq~
	<td>$prolockbirthdate_old<BR><B> $prolocktxt{'8'} ($prolock_txt) $hidedayormonth</B></td></tr>
	~;
	}
} else {
	$yymain .= qq~
	<td><font size="1">$dayormonth$txt{'566'}<input type="text" name="bday3" size="4" maxlength="4" value="$uyear"></font></td></tr>
	~;
}
	$yymain .= qq~
<!--- ###### Profile Lock Mod ###### --->
	<tr>
</replace>

<search for>
        <td width="320"><font size=2><b>$txt{'233'}:</b><BR>
        <font size="1">$txt{'421'}</font><BR><BR></td>
        <td><input type="text" name="dr" size="20" value="$dr"><BR><BR></td>
      </tr>~;
</search for>

<add after>

###### Profile Lock Mod ######
if ($enable_prolock == 1) {
	$yymain .= qq~
      <tr>
      <td width="320"><font size=2>$prolocktxt{'5'}:<BR>
        $prolocktxt{'6'}:</font></td>
	~;
	if($prolockgender_count==""){$prolockgender_count = 0;}
	if($prolockage_count==""){$prolockage_count = 0;}
	fopen(FILE, "$memberdir/$INFO{'username'}.prolock");
	@prolocksettings=<FILE>;
	fclose(FILE);
	foreach (@prolocksettings) { $_ =~ s~[\n\r]~~g; }
	$prolockgender_count = $prolocksettings[1];
	$prolockage_count = $prolocksettings[0];
	
	$yymain .= qq~
	<td><input type="text" name="prolockage_count" size=2 value="$prolockage_count"><font size=2> $prolocktxt{'10'} $prolock_max_allowed.</font><BR>
	<input type="text" name="prolockgender_count" size=2 value="$prolockgender_count"><font size=2> $prolocktxt{'10'} $prolock_max_allowed.</font>
	~;
	}
} else {
	fopen(FILE, "$memberdir/$INFO{'username'}.prolock");
	@prolocksettings=<FILE>;
	fclose(FILE);
	foreach (@prolocksettings) { $_ =~ s~[\n\r]~~g; }
	$prolockgender_count = $prolocksettings[1];
	$prolockage_count = $prolocksettings[0];
	if($prolockgender_count==""){$prolockgender_count = 0;}
	if($prolockage_count==""){$prolockage_count = 0;}
	
	$yymain .= qq~
	<td><input type="hidden" name="prolockage_count" value="$prolockage_count">
	<input type="hidden" name="prolockgender_count" value="$prolockgender_count"><font size=2>
	~;
###### Profile Lock Mod ######


</add after>

<search for>
	if($member{'settings6'} !~ /\A[0-9]+\Z/) { &fatal_error("$txt{'749'}"); }
	if ($member{'username'} =~ /\//){ &fatal_error($txt{'224'}); }
	if ($member{'username'} =~ /\\/){ &fatal_error($txt{'225'}); }
</search for>

<add before>

###### Profile Lock Mod ######
if ($enable_prolock == 1) {
	if($prolockgender_count==""){$prolockgender_count = 0;}
	if($prolockage_count==""){$prolockage_count = 0;}
	fopen(FILE, ">$memberdir/$member{'username'}.prolock", 1);
	print FILE "$member{'prolockage_count'}\n";
	print FILE "$member{'prolockgender_count'}\n";	
	fclose(FILE);
}
###### Profile Lock Mod ######


</add before>

<search for>
	&fatal_error("$txt{'240'} $txt{'69'} $txt{'241'}") if($member{'email'} !~ /^[0-9A-Za-z@\._\-]+$/);
	&fatal_error("$txt{'500'}") if(($member{'email'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($member{'email'} !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/));
</search for>

<add after>

###### Profile Lock Mod ######
if ($enable_prolock == 1 & $settings[7] ne 'Administrator') {
	if ($enable_prolock_mandatory == 1) {
	&fatal_error($prolocktxt{'1'}) if( $member{'bday1'} eq "" || $member{'bday2'} eq "" || $member{'bday3'} eq "" );
	&fatal_error($prolocktxt{'2'}) if( $member{'gender'} eq "" );
	}
}
###### Profile Lock Mod ######


</add after>

<search for>
		fopen( FILE, ">$memberdir/$member{'username'}.dat", 1);
		print FILE "$member{'passwrd1'}\n";
		print FILE "$member{'name'}\n";
		print FILE "$member{'email'}\n";
</search for>

<add before>

###### Profile Lock Mod ######
		if($member{'pla_old'} ne $member{'bday'}){$prolockage_change =1;} else {$prolockage_change = 0;}
		if($member{'plg_old'} ne $member{'gender'}){$prolockgender_change =1;} else {$prolockgender_change = 0;}
###### Profile Lock Mod ######


</add before>

<search for>
		if ($FORM{'hideemail'} ne "checked") { $FORM{'hideemail'} = ""; }
		print FILE "$FORM{'hideemail'}\n";
		fclose(FILE);
</search for>

<add after>

###### Profile Lock Mod ######
if ($enable_prolock == 1) {
	if ($enable_prolock_auto == 1 && $settings[7] ne 'Administrator') {
		if($prolockage_change == 1 && $prolockage_count < $prolock_max_allowed){$member{'prolockage_count'}=$member{'prolockage_count'}+1;}
		if($prolockgender_change == 1 && $prolockgender_count < $prolock_max_allowed){$member{'prolockgender_count'}=$member{'prolockgender_count'}+1;}
	}
	fopen(FILE, ">$memberdir/$member{'username'}.prolock", 1);
	print FILE "$member{'prolockage_count'}\n";
	print FILE "$member{'prolockgender_count'}\n";	
	fclose(FILE);
}
###### Profile Lock Mod ######

</add after>